import { LRParser } from '@lezer/lr';
import { LRLanguage, HighlightStyle, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "$tOVQPOOOkQPO'#CbOpQPO'#CeOuQPO'#CfOOQO'#Cl'#ClOOQO'#Ck'#CkQOQPOOOVQPO,58|OzQPO,59PO!PQPO,59QO!UQPO1G.hO!ZQPO1G.kO!cQPO1G.kO!hQPO1G.lO!pQPO1G.lOVQPO7+$SOOQO,59R,59ROOQO7+$V7+$VO!uQPO7+$VOOQO-E6e-E6eOOQO7+$W7+$WO!}QPO7+$WO#VQPO<<GnOOQO<<Gq<<GqP!^QPO'#CgOOQO<<Gr<<GrOVQPOAN=YO#[QPOG22tOOQOLD(`LD(`",
  stateData: "#c~O^OS~OQTORTOSTOaPObQOcRO~OVVO~OVWO~OVXO~ORZO~OR]O~OW_O~OTaOW`O~ORbO~OTdOW`O~OReO~OTgOW`O~OTiOW`O~OWjO~OTlO~OR~",
  goto: "!UaPPPPPPbPPbbhPPPr!OXSOV_jQ[WQ^XTc[^QUOQYVQf_RkjXTOV_j",
  nodeNames: "⚠ NuFormula String Number VariableName ) IFStatement ( Comma SUMStatement AVERAGEStatement",
  maxTerm: 19,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "*`~R`XY!TYZ!T]^!Tpq!Trs!Yxy$ryz$w{|$||}%p}!O$|!O!P%V!Q![%e!c!d%u!k!l&p!u!v&{#o#p'^~!YO^~~!]Wpq!Yqr!Yrs!us#O!Y#O#P!z#P;'S!Y;'S;=`$l<%lO!Y~!zOQ~~!}Xrs!Y!P!Q!Y#O#P!Y#U#V!Y#Y#Z!Y#b#c!Y#f#g!Y#h#i!Y#i#j#j~#mR!Q![#v!c!i#v#T#Z#v~#yR!Q![$S!c!i$S#T#Z$S~$VR!Q![$`!c!i$`#T#Z$`~$cR!Q![!Y!c!i!Y#T#Z!Y~$oP;=`<%l!Y~$wOV~~$|OT~~%PQ!O!P%V!Q![%e~%YP!Q![%]~%bPR~!Q![%]~%jQR~!O!P%]!Q![%e~%uOW~~%xP!x!y%{~&OP!g!h&R~&UP!t!u&X~&[P!c!d&_~&bP!i!j&e~&hP!g!h&k~&pOc~~&sP!h!i&v~&{Oa~~'OP!w!x'R~'UP!o!p'X~'^Ob~~'aR!Q!['j!c!i'j#T#Z'j~'mS}!O'y!Q!['j!c!i'j#T#Z'j~'|R!Q![(V!c!i(V#T#Z(V~(YS}!O(f!Q![(V!c!i(V#T#Z(V~(iR!Q![(r!c!i(r#T#Z(r~(uS}!O)R!Q![(r!c!i(r#T#Z(r~)UR!Q![)_!c!i)_#T#Z)_~)bS}!O)n!Q![)_!c!i)_#T#Z)_~)qR!Q![)z!c!i)z#T#Z)z~)}S!Q![)z!c!i)z#T#Z)z#q#r*Z~*`OS~",
  tokenizers: [0],
  topRules: {"NuFormula":[0,1]},
  tokenPrec: 109
});

// 定義語言
const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                Keyword: tags.keyword,
                String: tags.string,
                Number: tags.number,
                Operator: tags.operator,
                VariableName: tags.variableName,
                "( )": tags.paren,
                Comma: tags.separator,
            }),
        ],
    }),
});
// 語言標籤樣式
const nuformulaHighlightStyle = HighlightStyle.define([
    { tag: tags.keyword, color: "#B157D0" },
    { tag: tags.string, color: "#F7A452" },
    { tag: tags.number, color: "#5C9CE5" },
    { tag: tags.operator, color: "#404040" },
    { tag: tags.variableName, color: "#6E7796" },
]);
// 輸出語言
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula, nuformulaHighlightStyle };
